clear()
//
//------------------------------------------------------
//
//------------------------------------------------------
// SA for Rastrigin
disp('SA for Rastrigin');
//
//-----------------------------------------------------
//
//
function y=f(x)  // the function to optimize
n=prod(size(x));
y=n+sum(x.^2-cos(2*%pi*x));
endfunction
//
//-----------------------------------------------------
//
//
n=evstr(x_dialog('nombre de parametres de Rastrigin','2'));
Nmax=evstr(x_dialog('nombre maximal d''valuations','2000'));
timer(); 
u=rand(1,n);
//
xmin=-5*ones(1,n);
xmax=5*ones(1,n);
//
x0=xmin+(xmax-xmin).*u;  // random initialisation 
Neval=[];Fbest=[]; 
//
y0 = f(x0);
x = x0; y = y0;
//
alpha = 0.9; // taux de dcroissance de la temprature
T = 1;       // temprature initiale
s = 0.2;     // taille du voisinage de mutation
Nseuils=100  // nombre d'iteration avec dcroissance de T
Ns=Nmax/Nseuils;
//
icount=1; 
Neval=[];
Fbest=[];
for k = 1 : Ns
   T = alpha * T; 
   accept = 0;
   for l = 1 : int(Nmax/Ns)    
      x1 = x0 + s*(0.5*ones(x0) - rand (x0));
      y1 = f(x1);
      icount=icount+1;
      dy = y1 - y0;
      if rand() < exp (- dy / T) then
         x0 = x1; y0 = y1; accept = accept + 1;
         if y0 < y then x = x0; y = y0; end
      end
   end
   if accept < 0.25*Nmax/Ns then s = s / 2; end
   if accept > 0.75*Nmax/Ns then s = 2 * s; end
   x0 = x; y0 = y;
   Neval=[Neval;icount];
   Fbest=[Fbest;y];
end
//
disp('minimum obtained:');disp(x);
disp('corresponding value by f:');disp(Fbest($));
disp('fevaluation number:');disp(Neval($));
//
xset('window',0);clf();
plot2d(Neval,Fbest)

